<?php
$title = 'Подарки';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/gift.php");
if ($adm_id == 1) {

    $type = 3;

    switch ($act) {

        case 'category':

            if ($sys['modules']['gift'] == 0)
                exit(header('Location: /adm/gift'));

            $strow_kat = $connect->prepare("select * from `kat` where `id` = ? and `type` = ?");
            $strow_kat->execute(array($id, $type));
            $krow = $strow_kat->fetch();

            if ($krow) {

                $stmt_kat_gifts->execute(array($id));
                $kat_gifts = $stmt_kat_gifts->fetchColumn();

                echo '<div class="title">'.$krow['name'].' ('.$kat_gifts.')</div>';

                if (isset($_GET['edit'])) {
                    $strow_gift->execute(array($_GET['edit']));
                    $row = $strow_gift->fetch();
                    $file = GlobFiles::findById($_GET['edit'], GlobFiles::Files, GFGifts);
                    if ($row) {
                        if (isset($_POST['cancel'])) {
                            header('Location: /adm/gift/category/'.$id);
                        }
                        elseif (isset($_POST['ok'])) {
                            $error = '';
                            if (empty($_POST['name'])) {
                                $error.= 'Введите название!<br/>';
                            }
                            elseif (mb_strlen($_POST['name']) < 3 || mb_strlen($_POST['name']) > 250) {
                                $error.= 'Название должно содержать от 3 до 250 символов!<br/>';
                            }
                            if (empty($_POST['cena'])) {
                                $error.= 'Введите цену!<br/>';
                            }
                            elseif ($_POST['cena'] < 0.01) {
                                $error.= 'Цена не может быть меньше 0.01!<br/>';
                            }
                            if (!$file && !file_exists($_FILES['filename']['tmp_name'])) {
                                $error.= 'Вы не выбрали файл!<br/>';
                            } elseif (file_exists($_FILES['filename']['tmp_name'])) {
                                if (!BeforeUpload::AttachIMG($_FILES['filename'])) {
                                    $error.= 'Неверный тип файла!<br/>';
                                }
                                if ($_FILES['filename']['size'] > 1024 * 1024) {
                                    $error.= 'Максимальный размер файла - '.byte_conv(1024 * 1024).'!<br/>';
                                }
                            }
                            if ($error) {
                                echo '<div class="menu">'.$error.'</div>';
                            } else {
                                $cena = floatval(abs($_POST['cena']));
                                $stmt = $connect->prepare("update `gifts` set `name` = ?, `cena` = ? where `id` = ?");
                                if ($stmt->execute(array($_POST['name'], $cena, $_GET['edit']))) {

                                    if (file_exists($_FILES['filename']['tmp_name'])) {
                                        if ($file)
                                            unlink($file);
                                        $lid = $_GET['edit'];
                                        $files = $lid."_gift_".random_int(11111, 99999)."_".$_FILES['filename']['name'];
                                        move_uploaded_file($_FILES['filename']['tmp_name'], $_SERVER["DOCUMENT_ROOT"]."/files/".$files);
                                    }

                                    header('Location: /adm/gift/category/'.$id);

                                } else {
                                    echo '<div class="menu">Произошла ошибка!</div>';
                                }
                            }
                        }
                        echo '<div class="menu">
                        <form action="" method="POST" enctype="multipart/form-data">
                        Название:<br/><input type="text" name="name" value="'.$row['name'].'"><br/>
                        Цена:<br/><input type="text" name="cena" value="'.$row['cena'].'"><br/>
                        Картинка:'.($file ? iconFile($file).'<a data-noajax href="/files/'.basename($file).'">'.basename($file).'</a> ('.get_filesize($file).')' : '').'<br/><input type="file" name="filename"><br/>
                        <input type="submit" name="ok" value="Сохранить ('.intval($_GET['edit']).')">
                        <input type="submit" name="cancel" value="Отмена">
                        </form></div>';
                    } else {
                        header('Location: /adm/gift/category/'.$id);
                    }
                }
                elseif (isset($_GET['del'])) {
                    $strow_gift->execute(array($_GET['del']));
                    $row = $strow_gift->fetch();
                    if ($row) {
                        if (isset($_POST['cancel'])) {
                            header('Location: /adm/gift/category/'.$id);
                        }
                        elseif (isset($_POST['ok'])) {
                            delGift($_GET['del']);
                            header('Location: /adm/gift/category/'.$id);
                        }
                        echo '<div class="menu">
                        <form action="" method="POST">
                        <input type="submit" name="ok" value="Удалить ('.intval($_GET['del']).')">
                        <input type="submit" name="cancel" value="Отмена">
                        </form></div>';
                    } else {
                        header('Location: /adm/gift/category/'.$id);
                    }
                }
                elseif ($kat_gifts > 0) {
                    if (isset($_GET['del_all'])) {
                        if (isset($_POST['cancel'])) {
                            header('Location: /adm/gift/category/'.$id);
                        }
                        elseif (isset($_POST['ok'])) {
                            delKatGifts($id);
                            header('Location: /adm/gift/category/'.$id);
                        }
                        echo '<div class="menu">
                        <form action="" method="POST">
                        <input type="submit" name="ok" value="Подтвердить удаление всех подарков">
                        <input type="submit" name="cancel" value="Отмена">
                        </form></div>';
                    } else {
                        echo '<div class="forlink"><a href="?del_all" class="links"><img src="/img/delete.png" alt="delete">Удалить все подарки</a></div>';
                    }
                }

                if ($kat_gifts == 0) {
                    echo '<div class="menu">Подарков нет.</div>';
                } else {

                    $page = new Pagination($kat_gifts, 10);

                    $data = $connect->prepare("select * from `gifts` where `kat` = :kat order by `id` desc limit :start, 10");
                    $data->bindValue(':kat', $id, PDO::PARAM_INT);
                    $data->bindValue(':start', $page->start, PDO::PARAM_INT);
                    $data->execute();
                    $sql = $data->fetchAll();

                    foreach ($sql as $row) {

                        $file = GlobFiles::findById($row['id'], GlobFiles::Files, GFGifts);

                        echo '<div class="menu">
                        '.($file ? '<img src="/files/'.basename($file).'" alt="gift">' : '<div class="forbidden">Нет картинки!</div>').'<br/>
                        Название: '.$row['name'].'<br/>
                        Цена: '.rub($row['cena']).'
                        <div class="butt2">
                        <a href="?del='.$row['id'].'">Удалить</a>
                        <a href="?edit='.$row['id'].'">Редактировать</a>
                        </div>
                        </div>';

                    }

                    $page->navigation();

                }

                echo '<div class="title">Новый подарок</div>';

                if (isset($_POST['submit'])) {
                    $error = '';
                    if (empty($_POST['name'])) {
                        $error.= 'Введите название!<br/>';
                    }
                    elseif (mb_strlen($_POST['name']) < 3 || mb_strlen($_POST['name']) > 250) {
                        $error.= 'Название должно содержать от 3 до 250 символов!<br/>';
                    }
                    if (empty($_POST['cena'])) {
                        $error.= 'Введите цену!<br/>';
                    }
                    elseif ($_POST['cena'] < 0.01) {
                        $error.= 'Цена не может быть меньше 0.01!<br/>';
                    }
                    if (!file_exists($_FILES['filename']['tmp_name'])) {
                        $error.= 'Вы не выбрали файл!<br/>';
                    } else {
                        if (!BeforeUpload::AttachIMG($_FILES['filename'])) {
                            $error.= 'Неверный тип файла!<br/>';
                        }
                        if ($_FILES['filename']['size'] > 1024 * 1024) {
                            $error.= 'Максимальный размер файла - '.byte_conv(1024 * 1024).'!<br/>';
                        }
                    }
                    if ($error) {
                        echo '<div class="menu">'.$error.'</div>';
                    } else {
                        $cena = floatval(abs($_POST['cena']));
                        $stmt = $connect->prepare("insert into `gifts` set `kat` = ?, `name` = ?, `cena` = ?");
                        if ($stmt->execute(array($id, $_POST['name'], $cena))) {

                            $lid = $connect->LastInsertId();
                            $files = $lid."_gift_".random_int(11111, 99999)."_".$_FILES['filename']['name'];
                            move_uploaded_file($_FILES['filename']['tmp_name'], $_SERVER["DOCUMENT_ROOT"]."/files/".$files);

                            header('Location: /adm/gift/category/'.$id);

                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                }
                echo '<div class="menu">
                <form action="" method="POST" enctype="multipart/form-data">
                Название:<br/><input type="text" name="name"><br/>
                Цена:<br/><input type="text" name="cena"><br/>
                Картинка:<br/><input type="file" name="filename"><br/>
                <input type="submit" name="submit" value="Добавить">
                </form></div>';

                echo '<div class="forlink"><a href="/adm/gift" class="links">Категории подарков</a></div>';

            } else {
                header('Location: /adm/gift');
            }

            break;

        default:

            if (isset($_POST['settings'])) {

                $gift = intval($_POST['gift']);

                $sys['modules']['gift'] = $gift;

                write_ini_file(FILE_CONFIG, $sys);

                header('Location: /adm/gift');

            }

            echo '<div class="title">Настройки</div>
            <div class="menu">
            <form action="" method="POST">
            Статус модуля:<br/><select name="gift"><option value="1">Вкл.</option><option ' . ($sys['modules']['gift'] == 0 ? 'selected' : '') . ' value="0">Откл.</option></select>
            <input type="submit" name="settings" value="Сохранить">
            </form></div>';

            if ($sys['modules']['gift'] == 1) {

                echo '<div class="title">Категории подарков ('.$count_gift_kat.')</div>';

                $num_u = $connect->prepare("select count(*) from `kat` where `type` = ? and `id` = ?");
                $stmt_count = $connect->prepare("select count(*) from `gifts` where `kat` = ?"); 
                $strow = $connect->prepare("select * from `kat` where `id` = ?");

                if (isset($_GET['edit'])) {
                    $num_u->execute(array($type, $_GET['edit']));
                    if ($num_u->fetchColumn()) {
                        $strow->execute(array($_GET['edit']));
                        $row = $strow->fetch();
                        if (isset($_POST['cancel'])) {
                            header('location: /adm/gift');
                        }
                        elseif (isset($_POST['red'])) {
                            $error = '';
                            if (empty($_POST['name'])) {
                                $error.= 'Введите название!<br/>';
                            }
                            if ($error) {
                                echo '<div class="menu">'.$error.'</div>';
                            } else {
                                $stmt = $connect->prepare("update `kat` set `name` = ? where `id` = ?");
                                if ($stmt->execute(array($_POST['name'], $_GET['edit']))) {
                                    header('location: /adm/gift');
                                } else {
                                    echo '<div class="menu">Произошла ошибка!</div>';
                                }
                            }
                        }
                        echo '<div class="menu">
                        <form action="" method="POST">
                        Название:<br/><input type="text" name="name" value="'.$row['name'].'"><br/>
                        <input type="submit" name="red" value="Сохранить ('.intval($_GET['edit']).')">
                        <input type="submit" name="cancel" value="Отмена">
                        </form></div>';
                    } else {
                        header('location: /adm/gift');
                    }
                }
                elseif (isset($_GET['del'])) {
                    $num_u->execute(array($type, $_GET['del']));
                    if ($num_u->fetchColumn()) {
                        if (isset($_POST['yes'])) {
                            $stmt = $connect->prepare("delete from `kat` where `id` = ?");
                            if ($stmt->execute(array($_GET['del'])) && delKatGifts($_GET['del'])) {
                                header('location: /adm/gift');
                            } else {
                                echo '<div class="menu">Произошла ошибка!</div>';
                            }
                        }
                        elseif (isset($_POST['no'])) {
                            header('location: /adm/gift');
                        }
                        echo '<div class="menu">
                        <form action="" method="POST">
                        <input type="submit" name="yes" value="Удалить ('.intval($_GET['del']).')"/> 
                        <input type="submit" name="no" value="Отмена"/>
                        </form></div>';
                    } else {
                        header('location: /adm/gift');
                    }
                }
 
                if ($count_gift_kat == 0) {
                    echo '<div class="menu">Категорий нет!</div>';
                } else {

                    $page = new Pagination($count_gift_kat, 10);

                    $data = $connect->prepare("select * from `kat` where `type` = :type order by `id` desc limit :start, 10");
                    $data->bindValue(':type', $type, PDO::PARAM_INT);
                    $data->bindValue(':start', $page->start, PDO::PARAM_INT);
                    $data->execute();
                    $sql = $data->fetchAll();

                    foreach ($sql as $row) {

                        $stmt_count->execute(array($row['id']));
                        $count = $stmt_count->fetchColumn();

                        echo '<div class="menu">
                        Название: '.$row['name'].'<br/>
                        Подарков в категории: '.$count.'
                        <div class="butt2">
                        <a href="/adm/gift/category/'.$row['id'].'">Перейти в категорию</a><br/>
                        <a href="?del='.$row['id'].'">Удалить</a>
                        <a href="?edit='.$row['id'].'">Редактировать</a>
                        </div>
                        </div>';

                    }

                    $page->navigation();

                }

                echo '<div class="title">Новая категория</div>';

                if (isset($_POST['submit'])) {
                    $error = '';
                    if (empty($_POST['name'])) {
                        $error.= 'Введите название!<br/>';
                    }
                    if ($error) {
                        echo '<div class="menu">'.$error.'</div>';
                    } else {
                        $stmt = $connect->prepare("insert into `kat` set `type` = ?, `name` = ?");
                        if ($stmt->execute(array($type, $_POST['name']))) {
                            header('location: /adm/gift'); 
                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                }
                echo '<div class="menu">
                <form action="" method="POST">
                Название:<br/><input type="text" name="name"><br/>
                <input type="submit" name="submit" value="Добавить">
                </form></div>';

            }

    }

} else {
    header('location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>